=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2012-01-18 17:37:38 +0000
+++ bzrlib/bzrdir.py	2012-01-18 17:46:57 +0000
@@ -887,9 +887,9 @@
         format = BranchFormatMetadir.find_format(self, name=name)
         return format.get_reference(self, name=name)
 
-    def set_branch_reference(self, to_branch, name=None):
+    def set_branch_reference(self, target_branch, name=None):
         format = _mod_branch.BranchReferenceFormat()
-        format.initialize(self, target_branch=to_branch, name=name)
+        return format.initialize(self, target_branch=target_branch, name=name)
 
     def get_branch_transport(self, branch_format, name=None):
         """See BzrDir.get_branch_transport()."""

=== modified file 'bzrlib/controldir.py'
--- bzrlib/controldir.py	2012-01-18 17:37:38 +0000
+++ bzrlib/controldir.py	2012-01-18 17:46:57 +0000
@@ -230,13 +230,14 @@
             raise errors.NoColocatedBranchSupport(self)
         return None
 
-    def set_branch_reference(self, to_branch, name=None):
+    def set_branch_reference(self, target_branch, name=None):
         """Set the referenced URL for the branch in this controldir.
 
         :param name: Optional colocated branch name
-        :param to_branch: Branch to reference
+        :param target_branch: Branch to reference
         :raises NoColocatedBranchSupport: If a branch name was specified
             but colocated branches are not supported.
+        :return: The referencing branch
         """
         raise NotImplementedError(self.set_branch_reference)
 

=== modified file 'doc/en/release-notes/bzr-2.5.txt'
--- doc/en/release-notes/bzr-2.5.txt	2012-01-18 10:42:07 +0000
+++ doc/en/release-notes/bzr-2.5.txt	2012-01-18 17:46:57 +0000
@@ -46,6 +46,9 @@
 .. Changes that may require updates in plugins or other code that uses
    bzrlib.
 
+* ``ControlDir`` now has a new method ``set_branch_reference`` which can
+  be used for setting branch references. (Jelmer Vernooij)
+
 Internals
 *********
 

